



<!DOCTYPE html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      <meta http-equiv="x-ua-compatible" content="ie=edge">
      
      
      
      
        <meta name="lang:clipboard.copy" content="Copy to clipboard">
      
        <meta name="lang:clipboard.copied" content="Copied to clipboard">
      
        <meta name="lang:search.language" content="en">
      
        <meta name="lang:search.pipeline.stopwords" content="True">
      
        <meta name="lang:search.pipeline.trimmer" content="True">
      
        <meta name="lang:search.result.none" content="No matching documents">
      
        <meta name="lang:search.result.one" content="1 matching document">
      
        <meta name="lang:search.result.other" content="# matching documents">
      
        <meta name="lang:search.tokenizer" content="[\s\-]+">
      
      <link rel="shortcut icon" href="../assets/images/favicon.png">
      <meta name="generator" content="mkdocs-1.0.4, mkdocs-material-3.0.6">
    
    
      
        <title>The Python Console and editor - QGIS + Python = ❤❤</title>
      
    
    
      <link rel="stylesheet" href="../assets/stylesheets/application.451f80e5.css">
      
        <link rel="stylesheet" href="../assets/stylesheets/application-palette.22915126.css">
      
      
        
        
        <meta name="theme-color" content="#4caf50">
      
    
    
      <script src="../assets/javascripts/modernizr.1aa3b519.js"></script>
    
    
      
        <link href="https://fonts.gstatic.com" rel="preconnect" crossorigin>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,400,400i,700|Roboto+Mono">
        <style>body,input{font-family:"Roboto","Helvetica Neue",Helvetica,Arial,sans-serif}code,kbd,pre{font-family:"Roboto Mono","Courier New",Courier,monospace}</style>
      
    
    <link rel="stylesheet" href="../assets/fonts/material-icons.css">
    
    
  </head>
  
    
    
    <body dir="ltr" data-md-color-primary="green" data-md-color-accent="light-green">
  
    <svg class="md-svg">
      <defs>
        
        
      </defs>
    </svg>
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="__drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="__search" autocomplete="off">
    <label class="md-overlay" data-md-component="overlay" for="__drawer"></label>
    
      <a href="#the-python-console" tabindex="1" class="md-skip">
        Skip to content
      </a>
    
    
      <header class="md-header" data-md-component="header">
  <nav class="md-header-nav md-grid">
    <div class="md-flex">
      <div class="md-flex__cell md-flex__cell--shrink">
        <a href=".." title="QGIS + Python = ❤❤" class="md-header-nav__button md-logo">
          
            <i class="md-icon"></i>
          
        </a>
      </div>
      <div class="md-flex__cell md-flex__cell--shrink">
        <label class="md-icon md-icon--menu md-header-nav__button" for="__drawer"></label>
      </div>
      <div class="md-flex__cell md-flex__cell--stretch">
        <div class="md-flex__ellipsis md-header-nav__title" data-md-component="title">
          
            
              <span class="md-header-nav__topic">
                QGIS + Python = ❤❤
              </span>
              <span class="md-header-nav__topic">
                The Python Console and editor
              </span>
            
          
        </div>
      </div>
      <div class="md-flex__cell md-flex__cell--shrink">
        
          
            <label class="md-icon md-icon--search md-header-nav__button" for="__search"></label>
            
<div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="__search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="query" data-md-state="active">
      <label class="md-icon md-search__icon" for="__search"></label>
      <button type="reset" class="md-icon md-search__icon" data-md-component="reset" tabindex="-1">
        &#xE5CD;
      </button>
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="result">
          <div class="md-search-result__meta">
            Type to start searching
          </div>
          <ol class="md-search-result__list"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
          
        
      </div>
      
    </div>
  </nav>
</header>
    
    <div class="md-container">
      
        
      
      
      <main class="md-main">
        <div class="md-main__inner md-grid" data-md-component="container">
          
            
              <div class="md-sidebar md-sidebar--primary" data-md-component="navigation">
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    <nav class="md-nav md-nav--primary" data-md-level="0">
  <label class="md-nav__title md-nav__title--site" for="__drawer">
    <a href=".." title="QGIS + Python = ❤❤" class="md-nav__button md-logo">
      
        <i class="md-icon"></i>
      
    </a>
    QGIS + Python = ❤❤
  </label>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
      


  <li class="md-nav__item">
    <a href=".." title="Before We Start" class="md-nav__link">
      Before We Start
    </a>
  </li>

    
      
      
      

  


  <li class="md-nav__item md-nav__item--active">
    
    <input class="md-toggle md-nav__toggle" data-md-toggle="toc" type="checkbox" id="__toc">
    
      
    
    
      <label class="md-nav__link md-nav__link--active" for="__toc">
        The Python Console and editor
      </label>
    
    <a href="./" title="The Python Console and editor" class="md-nav__link md-nav__link--active">
      The Python Console and editor
    </a>
    
      
<nav class="md-nav md-nav--secondary">
  
  
    
  
  
    <label class="md-nav__title" for="__toc">Table of contents</label>
    <ul class="md-nav__list" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#before-starting" title="Before Starting" class="md-nav__link">
    Before Starting
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#exploring-the-console" title="Exploring the console" class="md-nav__link">
    Exploring the console
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#exercise-using-the-console" title="Exercise: Using the console" class="md-nav__link">
    Exercise: Using the console
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#running-commands" title="Running Commands" class="md-nav__link">
    Running Commands
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#exercise-first-python-commands" title="Exercise: First Python commands" class="md-nav__link">
    Exercise: First Python commands
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#exercise-first-pyqgis-commands" title="Exercise: First PyQGIS commands" class="md-nav__link">
    Exercise: First PyQGIS commands
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#intro-the-iface-object" title="Intro the iface object" class="md-nav__link">
    Intro the iface object
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#exercise-new-project-from-pyqgis" title="Exercise: New project from PyQGIS" class="md-nav__link">
    Exercise: New project from PyQGIS
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#exercise-access-the-main-canvas" title="Exercise: Access the main canvas" class="md-nav__link">
    Exercise: Access the main canvas
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
      
      
      
      
    </ul>
  
</nav>
    
  </li>

    
      
      
      


  <li class="md-nav__item">
    <a href="../startup/" title="Startup Scripts" class="md-nav__link">
      Startup Scripts
    </a>
  </li>

    
      
      
      


  <li class="md-nav__item">
    <a href="../expression_functions/" title="Custom Expression Functions" class="md-nav__link">
      Custom Expression Functions
    </a>
  </li>

    
      
      
      


  <li class="md-nav__item">
    <a href="../processing/" title="Processing Scripts" class="md-nav__link">
      Processing Scripts
    </a>
  </li>

    
      
      
      


  <li class="md-nav__item">
    <a href="../project_macros/" title="Project Macros" class="md-nav__link">
      Project Macros
    </a>
  </li>

    
      
      
      


  <li class="md-nav__item">
    <a href="../bonus/" title="Bonus Round!!" class="md-nav__link">
      Bonus Round!!
    </a>
  </li>

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
              <div class="md-sidebar md-sidebar--secondary" data-md-component="toc">
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    
<nav class="md-nav md-nav--secondary">
  
  
    
  
  
    <label class="md-nav__title" for="__toc">Table of contents</label>
    <ul class="md-nav__list" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#before-starting" title="Before Starting" class="md-nav__link">
    Before Starting
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#exploring-the-console" title="Exploring the console" class="md-nav__link">
    Exploring the console
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#exercise-using-the-console" title="Exercise: Using the console" class="md-nav__link">
    Exercise: Using the console
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#running-commands" title="Running Commands" class="md-nav__link">
    Running Commands
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#exercise-first-python-commands" title="Exercise: First Python commands" class="md-nav__link">
    Exercise: First Python commands
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#exercise-first-pyqgis-commands" title="Exercise: First PyQGIS commands" class="md-nav__link">
    Exercise: First PyQGIS commands
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#intro-the-iface-object" title="Intro the iface object" class="md-nav__link">
    Intro the iface object
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#exercise-new-project-from-pyqgis" title="Exercise: New project from PyQGIS" class="md-nav__link">
    Exercise: New project from PyQGIS
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#exercise-access-the-main-canvas" title="Exercise: Access the main canvas" class="md-nav__link">
    Exercise: Access the main canvas
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
      
      
      
      
    </ul>
  
</nav>
                  </div>
                </div>
              </div>
            
          
          <div class="md-content">
            <article class="md-content__inner md-typeset">
              
                
                
                <h1 id="the-python-console">The Python console</h1>
<p><strong>API Note:</strong> Any QGIS APIs referenced will link out to the <a href="https://qgis.org/pyqgis/master">Python API Docs</a>.</p>
<h3 id="before-starting">Before Starting</h3>
<p>Open the <code>project.qgz</code></p>
<h3 id="exploring-the-console">Exploring the console</h3>
<p>The Python Console and Python script editor is a great way to explore the 
QGIS api in order to try out the logic of your code before adding it to you scripts.</p>
<p>We won't spend long in here, just enough to try out some basic QGIS APIs and get used to the UI.</p>
<h4 id="exercise-using-the-console">Exercise: Using the console</h4>
<p>Open the console using <code>Plugins -&gt; Python Console</code></p>
<h3 id="running-commands">Running Commands</h3>
<p>Inside the console we can run any commands we want to try. This is a full interactive Python console so any
python code will work here.</p>
<h4 id="exercise-first-python-commands">Exercise: First Python commands</h4>
<p>Try something basic like the following and hit enter</p>
<pre><code>print(&quot;foss4g rocks&quot;)
</code></pre>

<p>The output is:</p>
<pre><code>foss4g rocks
</code></pre>

<h4 id="exercise-first-pyqgis-commands">Exercise: First PyQGIS commands</h4>
<p>Lets try some QGIS commands. Try each one and check the results</p>
<pre><code>print(Qgis.QGIS_RELEASE_NAME)
</code></pre>

<pre><code>print(iface.activeLayer().name())
</code></pre>

<pre><code>print(iface.activeLayer().featureCount())
</code></pre>

<h4 id="intro-the-iface-object">Intro the <code>iface</code> object</h4>
<p>QGIS exposes a object called <code>iface</code> (<a href="https://qgis.org/pyqgis/master/gui/other/QgisInterface.html?#module-QgisInterface">QgisInterface</a>). 
This object exposes methods that you can use to make some more complex operations easier. It's a wrapper around some of
the lower level object.  One example is <code>iface.newProject()</code>.</p>
<h4 id="exercise-new-project-from-pyqgis">Exercise: New project from PyQGIS</h4>
<p>Run the following command to create a new project</p>
<pre><code>iface.newProject()
</code></pre>

<h4 id="exercise-access-the-main-canvas">Exercise: Access the main canvas</h4>
<p>We can access the main canvas and it's scale function from here.</p>
<pre><code>iface.mapCavnas().scale()
</code></pre>

<p>Lets move on the the script editor</p>
<h1 id="the-script-editor">The script editor</h1>
<h3 id="before-starting_1">Before Starting</h3>
<p>Open the <code>project.qgz</code></p>
<p>From inside the console we can open the script editor. This editor can be used to write more complex scripts where the console
is normally only used for smaller one off logic.</p>
<h4 id="exercise-opening-the-editor">Exercise: Opening the editor</h4>
<p>Open the editor from inside the Python Console using the following button and the script editor will open on the left. </p>
<p><img alt="Function Editor" src="../img/editor.png" /></p>
<p>For a quick test we can write the a simple one line command and run the script</p>
<h4 id="exercise-running-the-first-commands">Exercise: Running the first commands</h4>
<pre><code>print(iface.activeLayer().name())
</code></pre>

<p><img alt="Function Editor" src="../img/editor_output.png" /></p>
<h5 id="tip-run-selected-text">Tip: Run selected text</h5>
<p>You can run just the selected text as well with <code>Ctrl+E</code> if you have a more complex script and need to check 
just parts of it.</p>
<h4 id="lower-case-all-layer-names">Lower case all layer names</h4>
<p>For this example we will create a new file using the plus button and write a script to lower case all the layer 
names in the project.</p>
<h4 id="exercise-import-qgis-modules">Exercise: Import QGIS modules</h4>
<p>Although QGIS has auto imported all the QGIS APIs into the console it's good practice to import them in your scripts to make
things clear</p>
<p>In the new script add the following at the top</p>
<pre><code>from qgis.core import QgsProject
</code></pre>

<p>Now we are ready to loop over all the layers and rename them to lower case.  Copy the following into the script editor 
and use the green edit button to run the script</p>
<h4 id="exercise-upper-case-all-layer-names">Exercise: Upper case all layer names</h4>
<pre><code>for layer in QgsProject.instance().mapLayers().values():
     print(layer.name())
     layer.setName(layer.name().upper())
     print(&quot;New name&quot;, layer.name())
</code></pre>

<p>The full script should look like this:</p>
<pre><code>from qgis.core import QgsProject
for layer in QgsProject.instance().mapLayers().values():
     print(layer.name())
     layer.setName(layer.name().upper())
     print(&quot;New name&quot;, layer.name())
</code></pre>

<p>The output in the console should be</p>
<p><img alt="Function Editor" src="../img/layer_name_out.png" /></p>
<p>and the layers panel with the new names</p>
<p><img alt="Function Editor" src="../img/legend_out.png" /></p>
                
                  
                
              
              
                


              
            </article>
          </div>
        </div>
      </main>
      
        
<footer class="md-footer">
  
    <div class="md-footer-nav">
      <nav class="md-footer-nav__inner md-grid">
        
          <a href=".." title="Before We Start" class="md-flex md-footer-nav__link md-footer-nav__link--prev" rel="prev">
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-back md-footer-nav__button"></i>
            </div>
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Previous
                </span>
                Before We Start
              </span>
            </div>
          </a>
        
        
          <a href="../startup/" title="Startup Scripts" class="md-flex md-footer-nav__link md-footer-nav__link--next" rel="next">
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Next
                </span>
                Startup Scripts
              </span>
            </div>
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-forward md-footer-nav__button"></i>
            </div>
          </a>
        
      </nav>
    </div>
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-footer-copyright">
        
        powered by
        <a href="https://www.mkdocs.org">MkDocs</a>
        and
        <a href="https://squidfunk.github.io/mkdocs-material/">
          Material for MkDocs</a>
      </div>
      
        
      
    </div>
  </div>
</footer>
      
    </div>
    
      <script src="../assets/javascripts/application.5e60981f.js"></script>
      
      <script>app.initialize({version:"1.0.4",url:{base:".."}})</script>
      
    
    
      
    
  </body>
</html>